//
// Created by jedi on 11/1/18.
//

#include "gfx/Font.h"
#include "gfx/Canvas.h"


namespace micromenu {

    Font::Font(raw_font &raw) noexcept : raw_data_(raw) {
    }

    void Font::print(int x, int y, char l, Canvas &c, bool inv) {
        int j = (l - ' ') % 32;
        for (int x_ = 0; x_ < 4; x_++)
            for (int y_ = 0; y_ < 5; y_++)
                if(raw_data_[j][x_ + 4 * y_])
                    c.draw(x + x_, y + y_, inv);
    }

    void Font::print(int x, int y, char *str, Canvas &c, bool inv) {
        for (int i = 0; str[i]; i++) {
            print(x + i * 5, y, str[i], c, inv);
        }
    }

    void Font::print(int x, int y, const char *str, Canvas &c, bool inv) {
        for (int i = 0; str[i]; i++) {
            print(x + i * 5, y, str[i], c, inv);
        }
    }

}