//
// Created by jedi on 11/1/18.
//

#include "gfx/Canvas.h"

namespace micromenu {

    Canvas::Canvas(int w, int h) : width_(w), height_(h), buffer_(w * h) {
        clear();
    }

    void Canvas::clear() {
        for (int x = 0; x < width_; x++)
            for (int y = 0; y < height_; y++)
                buffer_.set(x * height_ + y, false);
    }

    void Canvas::draw(int x, int y, bool inv) {
        if(y < height_ && x < width_)
            buffer_.set(x * height_ + y, !inv);
    }

    void Canvas::print(int x, int y, const char *str, bool inv, Font &f) {
        f.print(x, y, str, *this, inv);
    }

    void Canvas::print(int x, int y, char *str, bool inv, Font &f) {
        f.print(x, y, str, *this, inv);
    }

    int Canvas::getWidth() {
        return width_;
    }

    int Canvas::getHeight() {
        return height_;
    }

}