//
// Created by jedi on 10/30/18.
//

#include "ssd1306.h"
#include "buttons.h"
#include <stdlib.h>
#include <stdint.h>
#include <hal/hal.h>

void hal_init_screen(int w, int h) {
    ssd1306_128x32_i2c_init();
    ssd1306_fillScreen( 0x00 );

    DDRD = 0;
    PORTD |= (1 << PC2) | (1 << PC3) | (1 << PC4) | (1 << PC5);
}

void hal_draw(int x, int y, int b){
    ssd1306_putPixels(x,  y, b&0xFF);
    ssd1306_putPixels(x,  y+8, b>>8);
}

void hal_clear(){
}


void hal_poll_input(bool *ptr) {
    int in = PIND & 0x3c;

    ptr[0] = !(in & (1 << PC2));
    ptr[1] = !(in & (1 << PC3));
    ptr[2] = !(in & (1 << PC4));
    ptr[3] = !(in & (1 << PC5));

}

void hal_render() {
    while (true) {
        render();
    }
}

void * operator new(unsigned int size)
{
    return malloc(size);
}

void operator delete(void * ptr)
{
    free(ptr);
}

void debug(const char* str){
    //TODO implement
}