
#include "hal/hal.h"
#include "node.h"
#include "gfx/Layout.h"

#include "example.h"

#include "gfx/Screen.h"
#include "gfx/Canvas.h"
#include "buttons.h"

#ifdef LINUX

#include <SDL2/SDL.h>
#include <stdio.h>
#include <iostream>

extern SDL_Window *window;
extern SDL_Event event;
extern SDL_Renderer *renderer;

#endif


micromenu::Screen screen(128, 32);
micromenu::Layout layout(screen);
menu *root;

//using micromenu::menu;
int main() {

    root = new menu("",
                    new menu("baz",
                             new menu("x",
                                      new fooValue("x x", 5),
                                      new blubValue("xxx", 5)
                             ),
                             new fooValue("I", 5),
                             new fooValue("II", 5),
                             new blubValue("III", 5),
                             new blubValue("IIII", 5)
                    ),
                    new menu("peng",
                             new fooValue("o", 5),
                             new fooValue("oo", 5),
                             new fooValue("o o", 5)
                    )
    );

    hal_render();
    return 0;
}

void render() {
    layout.apply(root);
    micromenu::input.poll();
    layout.render();
}

void micromenu::buttons::onPush(direction dir, bool state) {
    if(state) {
        node *c;
        if(dir == I_DOWN) {
            c = layout.cursor;
            node *parent = c->getParent();
            if((c = c->getNext()) || parent && (c = parent->getChild())) {
                parent->setCursor(c);
                layout.cursor = c;
            }
        } else if(dir == I_UP) {
            // TODO implement
        } else if(dir == I_RIGHT) {
            c = layout.cursor;
            c = c->getCursor();
            if(c) {
                layout.cursor = c;
            }
        } else if(dir == I_LEFT) {
            c = layout.cursor;
            c = c->getParent();
            if(c) {
                layout.cursor = c;
            }
        }

    }
}